<?php

/**
 * tercero_du_du_dir actions.
 *
 * @package    cartera
 * @subpackage tercero_du_du_dir
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class tercero_du_du_dirActions extends sfQuery {
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'INTERCEROS',
        'INTERCER_DU',
        'INTERCER_DU_DIR',
        'INTERCER_TIP',
        'DEPARTAMENTOS',
        'TS_NAT_JUR'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        'INTERCER_DU, LEFT' =>
        array(
            'id_mae_ter' => 'INTERCEROS'
        ),
        'INTERCER_DU_DIR, LEFT' =>
        array(
            'id_mt_ubi' => 'INTERCER_DU'
        ),
        'INTERCER_TIP, LEFT' =>
        array(
            'id_tip_ter' => 'INTERCEROS'
        ),
        'DEPARTAMENTOS, LEFT' =>
        array(
            'coddepto' => 'INTERCER_DU_DIR'
        ),
        'TS_NAT_JUR, LEFT' =>
        array(
            'id_nat_jur' => 'INTERCEROS'
        )
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'INTERCEROS' =>
        array(
            'id_mae_ter' => 'id_mae_ter',
            'num_doc' => 'num_doc',
            'codigo' => 'codigo',
            'razon_soc' => 'razon_soc',
            'id_tip_ter' => 'id_tip_ter',
            'id_tipo_doc' => 'id_tipo_doc',
            'dv' => 'dv',
            'razon_soc' => 'razon_soc',
            'pnombre' => 'pnombre',
            'snombre' => 'snombre',
            'papellido' => 'papellido',
            'sapellido' => 'sapellido',
            'id_nat_jur' => 'id_nat_jur',
            'estado_ter' => 'estado_ter',
            'num_doc,||, - ,||,razon_soc' => 'completo'
        ),
        'INTERCER_DU_DIR' =>
        array(
            'id_ubi_dir' => 'id_ubi_dir',
            'direccion' => 'direccion',
            'tel' => 'tel',
            'ciudad' => 'ciudad',
            'coddepto' => 'coddepto',
            'id_pais' => 'id_pais'
        ),
        'INTERCER_TIP' =>
        array(
            'razon_soc' => 'usa_rac_soc'
        ),
        'DEPARTAMENTOS' =>
        array(
            'desdepto' => 'desdepto'
        ),
        'TS_NAT_JUR' =>
        array(
            'desc_jur' => 'desc_jur',
            'es_pos' => 'es_pos'
        ),
        'INTERCER_DU' =>
        array(
            'id_mt_ubi' => 'id_mt_ubi',
            'mail' => 'mail'
        )
    ); //por cada tabla especificar los campos del select
    
        
    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */

    protected $table_field_conditions = array(
        'INTERCEROS' => array(
            'id_mae_ter, a' => array('!=' => array(-1)),
            'id_mae_ter, b' => array('=' => array('id_mae_ter')),
            'estado_ter' => array('=' => array('estado_ter')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        ),
        'TS_NAT_JUR' => array(
            'id_nat_jur, a' => array('!=' => array(-1)),
            'id_nat_jur, b' => array('=' => array('id_nat_jur')),
            'es_pos' => array('=' => array('es_pos'))
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(
        'INTERCEROS' =>
        array(
            'num_doc' => array('LIKE' => array('input', '%')),
            'razon_soc' => array('LIKEALLPLUS' => array('input', '%'))
        )
    ); // filtros de condicion or
    protected $fields_orderBy = array(
        'num_doc'
    ); //campos para el ordenamiento de la consulta
    protected $query_qualifier = 'DISTINCT'; //Para eliminar filas repetidas

    /*
     * Variables manejo de log
     */
    //true - consulta de administracion
    protected $is_admin = true;
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;

    // Validate
    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Add
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateAdd(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Update
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateUpdate(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Remove
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateRemove(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    

    /**
     * Acciones anteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function preprocessRequest($Action, sfWebRequest $request) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    /**
     * Acciones posteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function postprocessRequest($Action, sfWebRequest $request, $list_data_post) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

}
